<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Default.aspx.cs" Theme="adm"
    StylesheetTheme="adm" MasterPageFile="~/adm/sc/admin.master" Inherits="adm_sc_categories_Default" %>

<asp:Content ID="hd" ContentPlaceHolderID="HeadContent" runat="server">
    <title>
        <%= Config.GetUrlCaption() %>
        | Administration | Manage Categories</title>
</asp:Content>
<asp:Content ID="MainContent" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <asp:UpdateProgress ID="UpdateProgress2" runat="server">
        <ProgressTemplate>
            <div class="item_pad_4_c">
                <img src="<%=  Config.GetUrl("images/loading.gif") %>" />
            </div>
        </ProgressTemplate>
    </asp:UpdateProgress>
    <asp:UpdatePanel ID="UpdatePanel2" UpdateMode="Conditional" runat="server" RenderMode="Inline">
        <ContentTemplate>
            <div class="vkbox">
                <div class="vkbox-header">
                    <h3>
                        Manage Categores!</h3>
                </div>
                <div class="vkbox-body">
                    <div id="msg" runat="server">
                    </div>
                    <div class="form-horizontal">
                        <fieldset>
                            <div class="control-group">
                                <label class="control-label" for="<%= txt_search.ClientID %>">
                                    Search:</label>
                                <div class="controls">
                                    <asp:TextBox ID="txt_search" MaxLength="100" Width="300" runat="server"></asp:TextBox>&nbsp;
                                    <asp:Button ID="btn_search" runat="server" Text="Search" OnClick="btn_search_Click" />
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="<%= drp_filter.ClientID %>">
                                    Filter Records:</label>
                                <div class="controls">
                                    <asp:DropDownList ID="drp_filter" OnSelectedIndexChanged="drp_filter_SelectedIndexChanged"
                                        AutoPostBack="true" runat="server">
                                        <asp:ListItem Text="General" Value="3"></asp:ListItem>
                                        <asp:ListItem Text="Videos" Value="0" Selected="True"></asp:ListItem>
                                        <asp:ListItem Text="Channels" Value="2"></asp:ListItem>
                                        <asp:ListItem Text="Abuse Types" Value="4"></asp:ListItem>
                                       
                                    </asp:DropDownList>
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="<%= drp_fstatus.ClientID %>">
                                    Select Status:</label>
                                <div class="controls">
                                    <asp:DropDownList ID="drp_fstatus" AutoPostBack="true" runat="server" OnSelectedIndexChanged="drp_fstatus_SelectedIndexChanged">
                                        <asp:ListItem Text="All" Value="2" Selected="True"></asp:ListItem>
                                        <asp:ListItem Text="Public" Value="0"></asp:ListItem>
                                        <asp:ListItem Text="Private" Value="1"></asp:ListItem>
                                    </asp:DropDownList>
                                </div>
                            </div>
                            <div class="control-group">
                                <label class="control-label" for="<%= drp_order.ClientID %>">
                                    Order:</label>
                                <div class="controls">
                                    <asp:DropDownList ID="drp_order" AutoPostBack="true" runat="server" OnSelectedIndexChanged="drp_order_SelectedIndexChanged">
                                        <asp:ListItem Text="Category Name DESC" Value="categoryname desc" Selected="True"></asp:ListItem>
                                        <asp:ListItem Text="Category Name ASC" Value="categoryname asc"></asp:ListItem>
                                        <asp:ListItem Text="Priority DESC" Value="priority desc"></asp:ListItem>
                                        <asp:ListItem Text="Priority ASC" Value="priority asc"></asp:ListItem>
                                        <asp:ListItem Text="isPrivate" Value="isprivate desc"></asp:ListItem>
                                        <asp:ListItem Text="CategoryID DESC" Value="categoryid desc"></asp:ListItem>
                                        <asp:ListItem Text="CategoryID ASC" Value="categoryid asc"></asp:ListItem>
                                    </asp:DropDownList>
                                </div>
                            </div>
                        </fieldset>
                    </div>
                </div>
                <div class="vkbox-footer">
                    <a href="Process.aspx" class="btn btn-primary btn-small">Add Category</a>
                </div>
            </div>
            <asp:Panel ID="pnl_main" runat="server">
                <div class="vkbox">
                    <div class="vkbox-header">
                        <h3>
                            Category List!</h3>
                    </div>
                    <div class="vkbox-body">
                        <div class="item">
                            <asp:DataList ID="MyList" Width="100%" RepeatColumns="1" RepeatDirection="Vertical"
                                runat="server" OnItemDataBound="MyList_ItemDataBound">
                                <HeaderTemplate>
                                    <table class="table table-bordered table-striped">
                                        <thead>
                                            <tr>
                                                <th width="15%">
                                                    CategoryID
                                                </th>
                                                <th width="35%">
                                                    Category Name
                                                </th>
                                                <th width="35%">
                                                    Term
                                                </th>
                                                <th width="15%">
                                                    ...
                                                </th>
                                            </tr>
                                        </thead>
                                    </table>
                                </HeaderTemplate>
                                <ItemTemplate>
                                    <table class="table table-bordered table-striped">
                                        <tbody>
                                            <tr>
                                                <td style="width: 15%;">
                                                    <asp:Label ID="lbl_categoryid" runat="server" Text='<%# ((Category_Struct)Container.DataItem).ID %>' />
                                                    <asp:Label ID="lbl_type" runat="server" Text='<%# ((Category_Struct)Container.DataItem).Type %>'
                                                        Visible="false" />
                                                </td>
                                                <td style="width: 35%;">
                                                    <asp:Label ID="lbl_categoryname" runat="server" Text='<%# ((Category_Struct)Container.DataItem).Name %>' />
                                                </td>
                                                <td style="width: 35%;">
                                                    <asp:Label ID="lbl_term" runat="server" Text='<%# ((Category_Struct)Container.DataItem).Term %>' />
                                                </td>
                                                <td style="width: 10%;">
                                                    <asp:HyperLink ID="lnk_edit" runat="server">Edit</asp:HyperLink>&nbsp;
                                                    <asp:HyperLink ID="lnk_delete" runat="server">Delete</asp:HyperLink>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                </ItemTemplate>
                            </asp:DataList>
                        </div>
                    </div>
                    <div class="vkbox-footer">
                        <asp:LinkButton ID="lnk_Prev" CssClass="btn btn-primary btn-mini" runat="server" Text="Prev" OnClick="lnk_Prev_Click"></asp:LinkButton>
                        <asp:Repeater ID="rptPages" runat="server" OnItemCommand="rptPages_ItemCommand" OnItemDataBound="rptPages_ItemDataBound">
                            <ItemTemplate>
                                <asp:LinkButton ID="btnPage" CommandName="Page" CommandArgument="<%# Container.DataItem %>"
                                    Text='<%# Container.DataItem %>' runat="server"></asp:LinkButton>&nbsp;
                            </ItemTemplate>
                        </asp:Repeater>
                        <asp:LinkButton ID="lnk_Next" runat="server" CssClass="btn btn-primary btn-mini" Text="Next" OnClick="lnk_Next_Click"></asp:LinkButton>
                    </div>
                </div>
            </asp:Panel>
            <asp:Panel ID="pnl_norecord" runat="server">
                <div class="box">
                    <div class="box_b">
                        <div class="separator_10px">
                        </div>
                        <div class="separator_10px">
                        </div>
                        <div class="item_pad_4_c">
                            <h4>
                                No Category Found!</h4>
                        </div>
                        <div class="separator_10px">
                        </div>
                        <div class="separator_10px">
                        </div>
                    </div>
                </div>
            </asp:Panel>
        </ContentTemplate>
    </asp:UpdatePanel>
</asp:Content>
