using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Web.UI.HtmlControls;
using System.IO;

public partial class admin_secure_modules_video_mgt : System.Web.UI.UserControl
{
    private int _media_type = 0; // 0: video, 1: audio
    public int MediaType
    {
        set { _media_type = value; }
        get { return _media_type; }
    }

    public long VideoID
    {
        get
        {
            if (ViewState["VideoID"] != null)
                return (long)ViewState["VideoID"];
            else
                return 0;
        }
        set
        {
            ViewState["VideoID"] = value;
        }
    }


    public string UserName
    {
        get
        {
            if (ViewState["UserName"] != null)
                return ViewState["UserName"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["UserName"] = value;
        }
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        HideMessage();
        if (!Page.IsPostBack)
        {
            Set_Options(this.VideoID);
            if (Request.Params["action"] != null && Request.Params["action"] != "")
            {
                if (Request.Params["action"] == "delete")
                {
                    // Delete Video
                    Delete_Video();
                    
                }
            }
        }
    }

    private void Set_Options(long VideoID)
    {
        DataSet ds = VideoBLL.Return_Operation_Values(VideoID);
        if (ds.Tables[0].Rows.Count > 0)
        {
            int isenabled = int.Parse(ds.Tables[0].Rows[0]["isenabled"].ToString());
            int iscomment = int.Parse(ds.Tables[0].Rows[0]["iscomments"].ToString());
            int isreviewed = int.Parse(ds.Tables[0].Rows[0]["isreviewed"].ToString());
            int israting = int.Parse(ds.Tables[0].Rows[0]["isratings"].ToString());
            int isadult = int.Parse(ds.Tables[0].Rows[0]["isadult"].ToString());
            int isfeatured = Convert.ToInt32(ds.Tables[0].Rows[0]["isfeatured"].ToString());

            // enable - disable video
            if (isenabled == 1)
            {
                lnk_enable.Visible = false;
                lnk_disable.Visible = true;
            }
            else
            {
                lnk_enable.Visible = true;
                lnk_disable.Visible = false;
            }

            // enable - disable comment option
            if (iscomment == 1)
            {
                lnk_enablecomments.Visible = false;
                lnk_disablecomments.Visible = true;
               
            }
            else
            {
                lnk_enablecomments.Visible = true;
                lnk_disablecomments.Visible = false;
            }

            if (isreviewed == 1)
            {
                lnk_reviewed.Text = "Already Approved";
                lnk_reviewed.Enabled = false;
            }

            // enable - disable rating option
            if (israting == 1)
            {
                lnk_enablerating.Visible = false;
                lnk_disablerating.Visible = true;
            }
            else
            {
                lnk_enablerating.Visible = true;
                lnk_disablerating.Visible = false;
            }

            // enable - disable adult options
            if (isadult == 1)
            {
                lnk_adult.Visible = false;
                lnk_nonadult.Visible = true;
               
            }
            else
            {
                lnk_adult.Visible = true;
                lnk_nonadult.Visible = false;
            }

            // mark / unmark featured video
            if (isfeatured == 1)
            {
                lnk_fenabled.Visible = false;
                lnk_fdisabled.Visible = true;
            }
            else
            {
                lnk_fenabled.Visible = true;
                lnk_fdisabled.Visible = false;
            }
        }
    }

    protected void lnk_reviewed_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int OldValue = Convert.ToInt32(VideoBLL.Get_Field_Value(VideoID, "isreviewed"));
        VideoBLL.Update_IsReviewed(this.VideoID,OldValue, 1, this.UserName,this.MediaType);
        ShowMessage("Video has been reviewed and approved, in case of disapprove video just click on disable link");
    }
    protected void lnk_enable_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int OldValue = Convert.ToInt32(VideoBLL.Get_Field_Value(VideoID, "isenabled"));
        VideoBLL.Update_IsEnabled(this.VideoID,OldValue, 1,this.UserName,this.MediaType);
        Set_Options(this.VideoID);
        ShowMessage("Video has been enabled successfully");
    }
    protected void lnk_disable_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        int OldValue = Convert.ToInt32(VideoBLL.Get_Field_Value(VideoID, "isenabled"));
        VideoBLL.Update_IsEnabled(this.VideoID,OldValue, 0,this.UserName,this.MediaType);

        Set_Options(this.VideoID);
        ShowMessage("Video has been disabled successfully.");
    }
    protected void lnk_enablecomments_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }

        VideoBLL.Update_Field(this.VideoID, "1", "iscomments");

        Set_Options(this.VideoID);
        ShowMessage("Comments on selected video has been enabled.");
    }
    protected void lnk_disablecomments_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }

        VideoBLL.Update_Field(this.VideoID, "0", "iscomments");
        Set_Options(this.VideoID);
        ShowMessage("Comments on selected video has been disable.");
    }
    protected void lnk_deletevideo_Click(object sender, EventArgs e)
    {
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        Delete_Video();
    }

    // Delete video script
    private void Delete_Video()
    {
        VideoBLL.RemoveVideo(this.VideoID,this.MediaType);

        Response.Redirect( Config.GetUrl("adm/sc/videos/Default.aspx?status=deleted"));
    }

    protected void lnk_disablerating_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }

        VideoBLL.Update_Field(this.VideoID, "0", "israting");
        Set_Options(this.VideoID);
        ShowMessage("Rating option on selected video has been disabled.");

    }
    protected void lnk_enablerating_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        VideoBLL.Update_Field(this.VideoID, "1", "israting");
        Set_Options(this.VideoID);
        ShowMessage("Rating option on selected video has been enabled.");

    }

    protected void lnk_nonadult_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        VideoBLL.Update_Field(this.VideoID, "0", "isadult");
        Set_Options(this.VideoID);
        ShowMessage("Video marked as non Adult.");
    }
    protected void lnk_adult_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect( Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        VideoBLL.Update_Field(this.VideoID, "1", "isadult");
        Set_Options(this.VideoID);
        ShowMessage("Video marked as Adult.");
    }


    private void ShowMessage(string message)
    {
        pnl_error.Visible = true;
        lbl_error.Text = message;
    }

    private void HideMessage()
    {
        pnl_error.Visible = false;
        lbl_error.Text = "";
    }

    protected void lnk_fdisabled_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect(Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        VideoBLL.Update_Field(this.VideoID, "0", "isfeatured");
        Set_Options(this.VideoID);
        ShowMessage("Featured video has been marked as normal video.");
    }

    protected void lnk_fenabled_Click(object sender, EventArgs e)
    {
        // Check whether admin section is in readonly mode.
        if (!Config.isAdminActionAllowed())
        {
            Response.Redirect(Config.GetUrl("adm/sc/Default.aspx?action_error=true"));
            return;
        }
        VideoBLL.Update_Field(this.VideoID, "1", "isfeatured");
        Set_Options(this.VideoID);
        ShowMessage("Video has been marked as Featured Video");
    }
}
