﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class archive_Default : System.Web.UI.Page
{
    protected string NavigationClass = "chnl_left";
    protected string BodyClass = "chnl_right";

    protected void Page_Load(object sender, EventArgs e)
    {
        string meta_title = "";
        string meta_description = "";
        if (Site_Settings.NavigationSection == 1)
        {
            // right side navigation
            NavigationClass = "chnl_right_nav";
            BodyClass = "chnl_left_mn";
        }

        tags1.HeadingTitle = Resources.vsk.recenttopics; // Recent Topics

        if (Request.Params["y"] != null && Request.Params["m"] != null)
        {
            int month = Convert.ToInt32(Request.Params["m"]);
            int year = Convert.ToInt32(Request.Params["y"]);
            string monthname = UtilityBLL.ReturnMonthName(month);

            if (Config.isVideos())
            {
                // load recent videos
                vd_sm1.HeadingTitle = Resources.vsk.monthyearaddedvideos.Replace("[date]",monthname + " " + year); // monthname + " " + year + " Added Videos";
                vd_sm1.Month = month;
                vd_sm1.Year = year;
                vd_sm1.Term = "";
                vd_sm1.SearchType = 1;
                vd_sm1.Order = "date_added desc";
                vd_sm1.See_All_Url = "videos/archive/" + Request.Params["y"].ToString() + "/" + Request.Params["m"].ToString() + ".aspx";
                vd_sm1.See_All_Url_Tooltip = Resources.vsk.monthyearvideotooltip.Replace("[date]", monthname + " " + year); //  "Browse all videos added in " + monthname + " " + year + "";
                vd_sm1.NoRecordFoundText = Resources.vsk.novideosaddedinmonth.Replace("[date]", monthname + " " + year); // "No Videos Added in " + monthname + " " + year;
                vd_sm1.Records = 12;
            }
            else
            {
                v_sect.Visible = false;
            }
                    

            meta_title = Resources.vsk.meta_archive_title.Replace("[date]", monthname + " " + year); // monthname + " " + year + " added videos, audio files, photos, galleries and blog posts
            meta_description = Resources.vsk.meta_archive_description.Replace("[date]", monthname + " " + year); // "Browse videos, audio files, blog posts, pictures, photos and wallpapers added in " + monthname + " " + year + "";

            set_bread_links("");
        }
        else
        {
            Response.Redirect(Config.GetUrl());
        }

        MetaTagsBLL.META_StaticPage(this.Page, (System.Web.UI.HtmlControls.HtmlHead)Page.Header, meta_title, meta_description, "", Config.GetUrl("archive/" + Request.Params["query"].ToString() + ".aspx"));

    }

    private void set_bread_links(string categoryname)
    {
        string _rooturl = Config.GetUrl();
        hm.HRef = _rooturl;
        hm.InnerHtml = Resources.vsk.home; // "Home";

        gal.HRef = Config.GetUrl("galleries/");
        gal.InnerHtml = Resources.vsk.galleries; // "Galleries";
     
        cats.HRef = Config.GetUrl("tags.aspx");
        cats.InnerHtml = Resources.vsk.tags; // "Tags";
  
    }
}