﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class galleries_category_Default : System.Web.UI.Page
{
    protected string NavigationClass = "chnl_left";
    protected string BodyClass = "chnl_right";
    protected void Page_Load(object sender, EventArgs e)
    {
        string meta_title = "";
        string meta_description = "";
        if (!Page.IsPostBack)
        {
            if (Site_Settings.NavigationSection == 1)
            {
                // right side navigation
                NavigationClass = "chnl_right_nav";
                BodyClass = "chnl_left_mn";
            }

            if (Request.Params["catname"] != null)
            {
                string tagname = UtilityBLL.UppercaseFirst(UtilityBLL.ReplaceHyphinWithSpace(Request.Params["catname"].ToString().Trim()), true);

                if (Config.isVideos())
                {
                    // load recent videos
                    vd_sm1.HeadingTitle = Resources.vsk.category_video_title.Replace("[term]", tagname); // tagname + " Videos";
                    vd_sm1.Term = tagname;
                    vd_sm1.SearchType = 0;
                    vd_sm1.Order = "date_added desc";
                    vd_sm1.See_All_Url = "videos/category/" + Request.Params["catname"].ToString() + ".aspx";
                    vd_sm1.See_All_Url_Tooltip = Resources.vsk.category_video_all.Replace("[term]", tagname.ToLower()); //  "Browse all [term] videos";
                    vd_sm1.NoRecordFoundText = Resources.vsk.category_video_notfound.Replace("[term]", tagname.ToLower()); // "No [term] videos found"
                    vd_sm1.Records = 12;
                }
                else
                {
                    v_sect.Visible = false;
                }


                meta_title = Resources.vsk.meta_category_title.Replace("[term]", tagname);  // [term] Videos, Audio Files, Photos, Wallpapers, Galleries and Blog Posts
                meta_description = Resources.vsk.meta_category_description.Replace("[term]", tagname);  // Browse videos, audio files, photos, wallpapers, galleries and blog posts related to term [term]

                set_bread_links(tagname);
            }
            else
            {
                Response.Redirect(Config.GetUrl());
            }

         
            MetaTagsBLL.META_StaticPage(this.Page, (System.Web.UI.HtmlControls.HtmlHead)Page.Header, meta_title, meta_description, "", Config.GetUrl("category/" + Request.Params["catname"].ToString() + ".aspx"));
            
        }
    }

    private void set_bread_links(string categoryname)
    {
        string _rooturl = Config.GetUrl();
        hm.HRef = _rooturl;
        hm.InnerHtml = Resources.vsk.home; 

        gal.HRef = Config.GetUrl("galleries/");
        gal.InnerHtml = Resources.vsk.galleries; // "Galleries";
        gal.Title = Resources.vsk.photogalleries;

        cats.HRef = Config.GetUrl("galleries/categories/");
        cats.InnerHtml = Resources.vsk.categories; // "Categories";
        cats.Title = Resources.vsk.categories;

        cat.InnerHtml = categoryname;

    }
}