﻿<%@ WebHandler Language="C#" Class="media" %>

using System;
using System.Web;
using System.Text;
using System.Collections.Generic;


public class media : IHttpHandler
{

    // Ajax version of rec_ph_v2.ascx script
    string handler_path = Config.GetUrl("handlers/nav/media.ashx");
    public string NoRecordFoundText = "No Records Found!";
    private string Term = ""; // to load photos based on term
    private int SearchType = 0; // 0: category match, 1: tag cloud match, 2: category or tag match, 3: broad search (category, tag, title, description)
    public int isfeatured = 2; // 0: normal, 1: wallpaper, 2: both
    public int isAudio = 0; // 0: video, 1: audio, 2: both
    public int CategoryID = 0; // Backward compatibility with old vsk 5.6
    public int isPrivate = 0; // 0: public, 1: private, 2: unlisted, 3: all
    public int isAdult = 2; //0: non adult, 1: adult, 2: both
    public int isExternal = 3; // 0: website videos, 1: embed videos
    private string Order = "added_date desc";
    private int Records = 8;
    private string See_All_Url = "";
    private string See_All_Text = "see all";
    private string See_All_Url_Tooltip = "";
    private string UserName = ""; // Load user specific records
    private int isEnabled = 1; // 1: Only enabled records, 0: Disabled Records, 2: Both enabled and disabled records
    private int isApproved = 1; // 1: Only approved records, 0: Not reviewed records only, 2: Both approved and unapproved records
    private int Filter = 0; // (0: All Time, 1: Today Viewed, 2: This Week Viewed, 3: This Month Viewed)
    public int AddedFilter = 0; // 0 All Time, 1: Today Added, 2: This Week Added, 3: This Month Added
    private int Month = 0; // month id to filter record based on month
    private int Year = 0; // year to filter records based on year
    private int PageNumber = 1;
    private int TotalPages = 0;
    private int TotalColumns = 4;
    private bool EditMode = false;
    private long AlbumId = 0; // filter audio / video via albumid
    public bool EnableNavigation = false; // enable top navigation (recent, viewed, liked, favorited etc)
    public string NavigationCssClass = "nav nav-tabs";
    public string NavigationActiveLinkCssClass = "active";
    public string NavigationLinkCssClass = "";
    public int NavigationActiveTab = 0; // 0: Recent, 1: View, 2: Like, 3: Favorite, 4: Comment
    public bool EnableAnimation = true; // Slide show animation when ajax event is called
    // Advance Order Links
    public string[] NavigationLinks = new string[] { Resources.vsk.recent, Resources.vsk.viewed, Resources.vsk.favorites, Resources.vsk.liked, Resources.vsk.comments };
    public string[] NavigationLinkOrderFields = new string[] { "v.date_added desc", "v.views desc", "v.favorites", "v.liked desc", "v.comments desc" };
    // Advance Date Filter Links
    public bool EnableDateFilterNavigation = false; // enable date filter navigation links (Today, This Week, This Month, All Time)
    public string DateFilterNavigationCssClass = "item_pad_4 bx_br_bt hor_lst";
    public string DateFilterLinkCssClass = "";
    public string DateFilterActiveLinkCssClass = "active";
    
    public bool isCache = false; // true only in case of navigation is enabled
    public int Mode = 0;
    // Customized Video Item
    public bool ShowDate = true;
    public bool ShowTitle = true;
    public bool ShowUser = true;
    public bool ShowViews = true;
    public string Container = ""; // core container to load all output
    // Version 2.0 Properties
    public int ContentLayout = 0; // 0: content on bottom, 1:content on left side
    public int BoxWidth = 145; // complete width of box
    public int Width = 135;
    public int Height = 72;
    public int LeftWidth = 45; // % width of left side of box
    public int RightWidth = 54; // % width of right side of box
    public bool isHoverEffect = false; // hover effect on mouse move

    public int TitleLength = 35; // max length of title to show
    public int BoxSpace = 10; // space between each item
    public bool isAdmin = false; // show admin mode
    public bool ShowDownload = false;

    // Advance Options
    public bool LoadFavorites = false;
    public bool LoadLiked = false;
    
    public void ProcessRequest(HttpContext context)
    {
        context.Response.ContentType = "text/plain";

        if (context.Request.Params["term"] != null)
            this.Term = context.Request.Params["term"].ToString();

        if (context.Request.Params["isfeatured"] != null)
            this.isfeatured = Convert.ToInt32(context.Request.Params["isfeatured"]);
        
        if (context.Request.Params["aid"] != null)
            this.AlbumId = Convert.ToInt64(context.Request.Params["aid"]);

        if (context.Request.Params["isaudio"] != null)
            this.isAudio = Convert.ToInt32(context.Request.Params["isaudio"]);

        if (context.Request.Params["catid"] != null)
            this.CategoryID = Convert.ToInt32(context.Request.Params["catid"]);

        if (context.Request.Params["isprivate"] != null)
            this.isPrivate = Convert.ToInt32(context.Request.Params["isprivate"]);
        
        if (context.Request.Params["isadult"] != null)
            this.isAdult = Convert.ToInt32(context.Request.Params["isadult"]);
        
        if (context.Request.Params["isexternal"] != null)
            this.isExternal = Convert.ToInt32(context.Request.Params["isexternal"]);

        if (context.Request.Params["user"] != null)
            this.UserName = context.Request.Params["user"].ToString();

        if (context.Request.Params["month"] != null)
            this.Month = Convert.ToInt32(context.Request.Params["month"]);

        if (context.Request.Params["year"] != null)
            this.Year = Convert.ToInt32(context.Request.Params["year"]);

        if (context.Request.Params["filter"] != null)
            this.Year = Convert.ToInt32(context.Request.Params["filter"]);

        if (context.Request.Params["isenabled"] != null)
            this.isEnabled = Convert.ToInt32(context.Request.Params["isenabled"]);

        if (context.Request.Params["isapproved"] != null)
            this.isApproved = Convert.ToInt32(context.Request.Params["isapproved"]);

        if (context.Request.Params["order"] != null)
            this.Order = context.Request.Params["order"].ToString();

        if (context.Request.Params["records"] != null)
            this.Records = Convert.ToInt32(context.Request.Params["records"]);

        if (context.Request.Params["searchtype"] != null)
            this.SearchType = Convert.ToInt32(context.Request.Params["searchtype"]);

        if (context.Request.Params["pagenumber"] != null)
            this.PageNumber = Convert.ToInt32(context.Request.Params["pagenumber"]);

        if (context.Request.Params["totalpages"] != null)
            this.TotalPages = Convert.ToInt32(context.Request.Params["totalpages"]);

        if (context.Request.Params["tcolumns"] != null)
            this.TotalColumns = Convert.ToInt32(context.Request.Params["tcolumns"]);

        if (context.Request.Params["sallurl"] != null)
            this.See_All_Url = context.Request.Params["sallurl"].ToString();

        if (context.Request.Params["sallt"] != null)
            this.See_All_Text = context.Request.Params["sallt"].ToString();

        if (context.Request.Params["salltool"] != null)
            this.See_All_Url_Tooltip = context.Request.Params["salltool"].ToString();

        if (context.Request.Params["emode"] != null)
            this.EditMode = Convert.ToBoolean(context.Request.Params["emode"]);

        if (context.Request.Params["width"] != null)
            this.Width = Convert.ToInt32(context.Request.Params["width"]);

        if (context.Request.Params["height"] != null)
            this.Height = Convert.ToInt32(context.Request.Params["height"]);

        if (context.Request.Params["cnt"] != null)
            this.Container = context.Request.Params["cnt"].ToString();

        if (context.Request.Params["filter"] != null)
            this.Filter = Convert.ToInt32(context.Request.Params["filter"]);

        if (context.Request.Params["afilter"] != null)
            this.AddedFilter = Convert.ToInt32(context.Request.Params["afilter"]);

        if (context.Request.Params["sdate"] != null)
            this.ShowDate = Convert.ToBoolean(context.Request.Params["sdate"]);

        if (context.Request.Params["stitle"] != null)
            this.ShowTitle = Convert.ToBoolean(context.Request.Params["stitle"]);

        if (context.Request.Params["suser"] != null)
            this.ShowUser = Convert.ToBoolean(context.Request.Params["suser"]);
        
        if (context.Request.Params["sviews"] != null)
            this.ShowViews = Convert.ToBoolean(context.Request.Params["sviews"]);

        if (context.Request.Params["enablenav"] != null)
            this.EnableNavigation = Convert.ToBoolean(context.Request.Params["enablenav"]);
               
          if (context.Request.Params["enableanim"] != null)
            this.EnableAnimation = Convert.ToBoolean(context.Request.Params["enableanim"]);
        
         if (context.Request.Params["tab"] != null)
            this.NavigationActiveTab = Convert.ToInt32(context.Request.Params["tab"]);
        
         if (context.Request.Params["navcss"] != null)
            this.NavigationCssClass = context.Request.Params["navcss"].ToString();
        
          if (context.Request.Params["navactivecss"] != null)
            this.NavigationActiveLinkCssClass = context.Request.Params["navactivecss"].ToString();

          if (context.Request.Params["navlinkcss"] != null)
              this.NavigationLinkCssClass = context.Request.Params["navlinkcss"].ToString();

          if (context.Request.Params["iscache"] != null)
              this.isCache = Convert.ToBoolean(context.Request.Params["iscache"]);

          if (context.Request.Params["edfnav"] != null)
              this.EnableDateFilterNavigation = Convert.ToBoolean(context.Request.Params["edfnav"]);

          if (context.Request.Params["dnavcss"] != null)
              this.DateFilterNavigationCssClass = context.Request.Params["dnavcss"].ToString();

          if (context.Request.Params["dlinkcss"] != null)
              this.DateFilterLinkCssClass = context.Request.Params["dlinkcss"].ToString();

          if (context.Request.Params["dactivecss"] != null)
              this.DateFilterActiveLinkCssClass = context.Request.Params["dactivecss"].ToString();
        
          if (context.Request.Params["navarr"] != null)
          {
              string navarr = context.Request.Params["navarr"].ToString();
              if (navarr.Contains(","))
                  this.NavigationLinks = navarr.Split(char.Parse(","));
              else
                  this.NavigationLinks[0] = navarr;
          }

          if (context.Request.Params["navarrorder"] != null)
          {
              string navarr = context.Request.Params["navarrorder"].ToString();
              if (navarr.Contains(","))
                  this.NavigationLinkOrderFields = navarr.Split(char.Parse(","));
              else
                  this.NavigationLinkOrderFields[0] = navarr;
          }
         context.Response.Write(BindList());
    }

    public bool IsReusable
    {
        get
        {
            return false;
        }
    }

    private string BindList()
    {
        StringBuilder str = new StringBuilder();
        StringBuilder rotator_str = new StringBuilder();
        // generate top navigation if enabled
        if (this.EnableNavigation)
        {
            str.Append(Generate_Top_Navigation());
        }
        // generate datefilter navigation
        //if (this.EnableDateFilterNavigation)
        //{
        //    str.Append(Generate_DateFilter_Navigation());
        //}
        // query
        Video_Struct query = new Video_Struct();
        query.Term = this.Term;
        query.isFeatured = this.isfeatured;
        query.Type = this.isAudio;
        query.UserName = this.UserName;
        query.Month = this.Month;
        query.Year = this.Year;
        query.Filter = this.Filter;
        query.isEnabled = this.isEnabled;
        query.isReviewed = this.isApproved;
        query.isPrivate = this.isPrivate;
        query.isAdult = this.isAdult;
        query.isExternal = this.isExternal;
        query.Order = this.Order;
        query.PageSize = this.Records;
        query.SearchType = this.SearchType;
        query.DateFilter = this.AddedFilter;
        query.isCache = this.isCache;
        query.Mode = this.Mode;
        query.GalleryID = this.AlbumId;
        query.PageNumber = this.PageNumber;
        query.isPublished = 1; // only published videos
        query.LoadFavorites = this.LoadFavorites;
        query.LoadLiked = this.LoadLiked;
        VideoBLL vbll = new VideoBLL();
        List<Video_Struct> _list = vbll.Load_Videos_Limit(query);
        if (_list.Count > 0)
        {
            
            int i = 0;
            int counter = 0;
            VideoItem video = new VideoItem();
            str.Append("<div class=\"bx_br_bt item_pad_4\">\n");
            for (i = 0; i <= _list.Count - 1; i++)
            {
                counter = counter + 1;
                if (counter >= this.TotalColumns)
                {
                    counter = 0;
                    video.BreakLine = true;
                }
                // generate thumb rotator script for single video item 
                if (this.isAudio == 0 && _list[i].Embed_Script == "")
                    rotator_str.Append(UGeneral.Generate_Thumb_Rotator_Script(_list[i].ThumbFileName));
              
                // single comment item
                video.Type = this.isAudio;
                video.ShowDate = this.ShowDate;
                video.ShowTitle = this.ShowTitle;
                video.ShowAuthor = this.ShowUser;
                video.ShowViews = this.ShowViews;
                video.ShowDownloads = this.ShowDownload;
                video.Width = this.Width;
                video.Height = this.Height;
                video.isAdmin = this.isAdmin;
                video.isHoverEffect = this.isHoverEffect;
                video.BoxSpace = this.BoxSpace;

                video.TitleLength = this.TitleLength;
                // two level video listing
                video.ContentLayout = this.ContentLayout;
                video.BoxWidth = this.BoxWidth;
                video.LeftWidth = this.LeftWidth; // %
                video.RightWidth = this.RightWidth; // %
                
                // again reset breakline as false
                str.Append(video.Process(_list[i]));
                video.BreakLine = false;    
            }
            str.Append("<div class=\"clear\"></div>"); // clear floating items
            if (this.isAudio == 0)
                str.Append("<script type=\"text/javascript\">" + rotator_str.ToString() + "</script>"); // thumb rotator script
            str.Append("</div>\n");

            // ajax pagination
            str.Append("<div class=\"item_pad_4 ui-helper-clearfix\">");
            str.Append("<div style=\"float:left;width:38%;\">\n");
            str.Append("&nbsp;");
            str.Append("</div>\n");
            str.Append("<div style=\"float:left;width:20%; height:30px;\">\n");

            string parameters = "term=" + this.Term + "&catid=" + this.CategoryID + "&isfeatured=" + this.isfeatured + "&isaudio=" + this.isAudio + "&user=" + this.UserName + "&month=" + this.Month + "&year=" + this.Year + "&filter=" + this.Filter + "&isenabled=" + this.isEnabled + "&isapproved=" + this.isApproved + "&isprivate=" + this.isPrivate + "&isadult=" + this.isAdult + "&isexternal=" + this.isExternal + "&order=" + Order + "&records=" + this.Records + "&searchtype=" + SearchType + "&totalpages=" + this.TotalPages + "&sallurl=" + this.See_All_Url + "&sallt=" + this.See_All_Text + "&salltool=" + this.See_All_Url_Tooltip + "&tcolumns=" + this.TotalColumns + "&emode=" + this.EditMode + "&width=" + this.Width + "&height=" + this.Height + "&cnt=" + this.Container + "&afilter=" + this.AddedFilter + "&sdate=" + this.ShowDate + "&sviews=" + this.ShowViews + "&stitle=" + this.ShowTitle + "&suser=" + this.ShowUser + "&enablenav=" + this.EnableNavigation + "&navcss=" + this.NavigationCssClass + "&navactivecss=" + this.NavigationActiveLinkCssClass + "&enableanim=" + this.EnableAnimation + "&navlinkcss=" + this.NavigationLinkCssClass + "&edfnav=" + this.EnableDateFilterNavigation + "&dnavcss=" + DateFilterNavigationCssClass + "&dlinkcss=" + DateFilterLinkCssClass + "&dactivecss=" + DateFilterActiveLinkCssClass + "&aid=" + this.AlbumId;
            parameters = parameters + "" + Generate_Nav_Query();
            string ajax_event = "";
            string ajax_function_name = "Process_Req_Animate";
            if (!this.EnableAnimation)
                ajax_function_name = "Process_Req";
            if (PageNumber > 1)
            {
                // show previous link
                int prev_pagenumber = PageNumber - 1;
                if (prev_pagenumber < 1)
                    prev_pagenumber = 1;
                string prev_parameters = parameters + "&pagenumber=" + prev_pagenumber;

                ajax_event = ajax_function_name + "('" + handler_path + "','" + prev_parameters + "','#" + this.Container + "','GET',''); return false;";
                str.Append("<a href=\"#\" onclick=\"" + ajax_event + "\" title=\"Browse Previous Records\" class=\"btn btn-mini\"><i class=\"icon-arrow-left\"></i></a>&nbsp;");
            }
            if (PageNumber < TotalPages)
            {
                // show next link
                int next_pagenumber = PageNumber + 1;
                if (next_pagenumber > TotalPages)
                    next_pagenumber = TotalPages;
                string next_parameters = parameters + "&pagenumber=" + next_pagenumber;
               
                ajax_event = ajax_function_name + "('" + handler_path + "','" + next_parameters + "','#" + this.Container + "','GET',''); return false;";

                str.Append("<a href=\"#\" onclick=\"" + ajax_event + "\" title=\"Browse Next Records\" class=\"btn btn-mini\"><i class=\"icon-arrow-right\"></i></a>");
            }
            str.Append("</div>\n");
            str.Append("<div style=\"float:right;width:38%;\">\n");
            str.Append("<div class=\"item_pad_4_r\">\n");
            str.Append("<a href=\"" + Config.GetUrl(this.See_All_Url) + "\" title=\"" + this.See_All_Url_Tooltip + "\">" + this.See_All_Text + "</a>");
            str.Append("</div>\n");
            str.Append("</div>\n");
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>");
        }
        else
        {
            str.Append("<div class=\"bx_msg\">");
            str.Append("<h4>" + this.NoRecordFoundText + "</h4>");
            str.Append("</div>");
        }
        return str.ToString();
       
    }
    // Generate Top Navigation
    private string Generate_Top_Navigation()
    {
        StringBuilder str = new StringBuilder();
        string nav_param = "term=" + this.Term + "&catid=" + this.CategoryID + "&isfeatured=" + this.isfeatured + "&isaudio=" + this.isAudio + "&user=" + this.UserName + "&month=" + this.Month + "&year=" + this.Year + "&filter=" + this.Filter + "&isenabled=" + this.isEnabled + "&isapproved=" + this.isApproved + "&isprivate=" + this.isPrivate + "&isadult=" + this.isAdult + "&isexternal=" + this.isExternal + "&records=" + this.Records + "&searchtype=" + SearchType + "&pagenumber=1&totalpages=1&sallurl=" + this.See_All_Url + "&sallt=" + this.See_All_Text + "&salltool=" + this.See_All_Url_Tooltip + "&tcolumns=" + this.TotalColumns + "&emode=" + this.EditMode + "&width=" + this.Width + "&height=" + this.Height + "&cnt=" + this.Container + "&sdate=" + this.ShowDate + "&sviews=" + this.ShowViews + "&stitle=" + this.ShowTitle + "&suser=" + this.ShowUser + "&enablenav=" + this.EnableNavigation + "&navcss=" + this.NavigationCssClass + "&navactivecss=" + this.NavigationActiveLinkCssClass + "&enableanim=" + this.EnableAnimation + "&navlinkcss=" + this.NavigationLinkCssClass + "&iscache=" + this.isCache + "&edfnav=" + this.EnableDateFilterNavigation + "&dnavcss=" + DateFilterNavigationCssClass + "&dlinkcss=" + DateFilterLinkCssClass + "&dactivecss=" + DateFilterActiveLinkCssClass + "&aid=" + this.AlbumId;
        nav_param = nav_param + "" + Generate_Nav_Query();
        string ajax_function_name = "Process_Req_Animate";
        if (!this.EnableAnimation)
            ajax_function_name = "Process_Req";

        if (this.NavigationLinks.Length > 0 && this.NavigationLinkOrderFields.Length > 0)
        {
            string nav_ajax_event = "";
            string nav_active_css = "";
            int i = 0;
            str.Append("<div class=\"nmtabs\">\n");
            string navcss = "";
            if (this.NavigationCssClass != "")
                navcss = " class=\"" + NavigationCssClass + "\"";
            str.Append("<ul" + navcss + ">");
            for (i = 0; i <= this.NavigationLinks.Length - 1; i++)
            {
                nav_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + this.NavigationLinkOrderFields[i].ToString() + "&tab=" + i + "&afilter=" + this.AddedFilter + "','#" + this.Container + "','POST',''); return false;";
                if (this.NavigationActiveTab == i)
                    nav_active_css = " class=\"" + this.NavigationActiveLinkCssClass + "\"";
                else
                    nav_active_css = "";

                string linkcss = "";
                if (this.NavigationLinkCssClass != "")
                    linkcss = " class=\"" + this.NavigationCssClass + "\"";
                str.Append("<li " + nav_active_css + "><a" + linkcss + " href=\"#\" onclick=\"" + nav_ajax_event + "\">" + this.NavigationLinks[i].ToString() + "</a></li>\n");

            }
            // Generate Filter -> Today, this Week, this month added
            if (this.EnableDateFilterNavigation)
            {
                str.Append("<li class=\"dropdown\"><a href=\"#\" class=\"dropdown-toggle\" data-toggle=\"dropdown\">Filter <b class=\"caret\"></b></a>\n");
                str.Append("<ul class=\"dropdown-menu\">\n");
                str.Append(Generate_DateFilter());
                str.Append("</ul>\n");
                str.Append("</li>\n");
            }
            str.Append("</ul>");
            str.Append("<div class=\"clear\"></div>\n");
            str.Append("</div>\n");
        }

        return str.ToString();
    }
    // Generate Date Filter Navigation
    private string Generate_DateFilter()
    {
        StringBuilder str = new StringBuilder();
        string nav_param = "term=" + this.Term + "&catid=" + this.CategoryID + "&isfeatured=" + this.isfeatured + "&isaudio=" + this.isAudio + "&user=" + this.UserName + "&month=" + this.Month + "&year=" + this.Year + "&filter=" + this.Filter + "&isenabled=" + this.isEnabled + "&isapproved=" + this.isApproved + "&isprivate=" + this.isPrivate + "&isadult=" + this.isAdult + "&isexternal=" + this.isExternal + "&records=" + this.Records + "&searchtype=" + SearchType + "&pagenumber=1&totalpages=1&sallurl=" + this.See_All_Url + "&sallt=" + this.See_All_Text + "&salltool=" + this.See_All_Url_Tooltip + "&tcolumns=" + this.TotalColumns + "&emode=" + this.EditMode + "&width=" + this.Width + "&height=" + this.Height + "&cnt=" + this.Container + "&sdate=" + this.ShowDate + "&sviews=" + this.ShowViews + "&stitle=" + this.ShowTitle + "&suser=" + this.ShowUser + "&enablenav=" + this.EnableNavigation + "&navcss=" + this.NavigationCssClass + "&navactivecss=" + this.NavigationActiveLinkCssClass + "&enableanim=" + this.EnableAnimation + "&navlinkcss=" + this.NavigationLinkCssClass + "&iscache=" + this.isCache + "&edfnav=" + this.EnableDateFilterNavigation + "&dnavcss=" + DateFilterNavigationCssClass + "&dlinkcss=" + DateFilterLinkCssClass + "&dactivecss=" + DateFilterActiveLinkCssClass + "&aid=" + this.AlbumId;
        nav_param = nav_param + "" + Generate_Nav_Query();
        string ajax_function_name = "Process_Req_Animate";
        if (!this.EnableAnimation)
            ajax_function_name = "Process_Req";

        // current order sequence
        string _order = "v.date_added desc";
        string _tabs = "0";
        if (this.NavigationLinks.Length > 0 && this.NavigationLinkOrderFields.Length > 0)
        {
            int i = 0;
            for (i = 0; i <= this.NavigationLinks.Length - 1; i++)
            {
                if (this.NavigationActiveTab == i)
                {
                    _order = this.NavigationLinkOrderFields[i].ToString();
                    _tabs = i.ToString();
                }

            }
        }
        string today_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + _order + "&tab=" + _tabs + "&afilter=1','#" + this.Container + "','POST',''); return false;";
        string thisweek_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + _order + "&tab=" + _tabs + "&afilter=2','#" + this.Container + "','POST',''); return false;";
        string thismonth_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + _order + "&tab=" + _tabs + "&afilter=3','#" + this.Container + "','POST',''); return false;";
        string alltime_ajax_event = ajax_function_name + "('" + handler_path + "','" + nav_param + "&order=" + _order + "&tab=" + _tabs + "&afilter=0','#" + this.Container + "','POST',''); return false;";

        string today_active_css = "";
        string thisweek_active_css = "";
        string thismonth_active_css = "";
        string all_active_css = "";
        if (DateFilterLinkCssClass != "")
        {
            today_active_css = " class=\"" + this.DateFilterLinkCssClass + "\"";
            thisweek_active_css = " class=\"" + this.DateFilterLinkCssClass + "\"";
            thismonth_active_css = " class=\"" + this.DateFilterLinkCssClass + "\"";
            all_active_css = " class=\"" + this.DateFilterLinkCssClass + "\"";
        }
        switch (this.AddedFilter)
        {
            case 1:
                // today active
                today_active_css = " class=\"" + this.DateFilterActiveLinkCssClass + "\"";
                break;
            case 2:
                // this week active
                thisweek_active_css = " class=\"" + this.DateFilterActiveLinkCssClass + "\"";
                break;
            case 3:
                // this month active
                thismonth_active_css = " class=\"" + this.DateFilterActiveLinkCssClass + "\"";
                break;
            case 0:
                // all time active
                all_active_css = " class=\"" + this.DateFilterActiveLinkCssClass + "\"";
                break;
        }

        //str.Append("<div class=\"" + DateFilterNavigationCssClass + "\">\n");
        //str.Append("<ul>");
        str.Append("<li" + today_active_css + "><a href=\"#\" onclick=\"" + today_ajax_event + "\">" + Resources.vsk.today + "</a></li>\n");
        //str.Append("<li class=\"separator\">|</li>");
        str.Append("<li" + thisweek_active_css + "><a href=\"#\" onclick=\"" + thisweek_ajax_event + "\">" + Resources.vsk.thisweek + "</a></li>\n");
        //str.Append("<li class=\"separator\">|</li>");
        str.Append("<li" + thismonth_active_css + "><a href=\"#\" onclick=\"" + thismonth_ajax_event + "\">" + Resources.vsk.thismonth + "</a></li>\n");
        //str.Append("<li class=\"separator\">|</li>");
        str.Append("<li" + all_active_css + "><a href=\"#\" onclick=\"" + alltime_ajax_event + "\">" + Resources.vsk.alltime + "</a></li>\n");
        //str.Append("</ul>");
        //str.Append("<div class=\"clear\"></div>\n");
        //str.Append("</div>\n");

        return str.ToString();
    }
       
    // Generate query string for nav linkgs and nav order links array list
    private string Generate_Nav_Query()
    {
        return "&navarr=" + string.Join(",", this.NavigationLinks) + "&navarrorder=" + string.Join(",", this.NavigationLinkOrderFields);
    }
}