﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;

public partial class videos_featured_Default : System.Web.UI.Page
{

    protected string NavigationClass = "";
    protected string BodyClass = "";
    protected string BodyRight = "";
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            // process website layout
            Process_Layout();

            lst1.isListStatus = true;
            lst1.isListNav = true;
            lst1.Term = "";
            lst1.SearchType = 0;

            lst1.PageTitle = Resources.vsk.videos_featured_title; // "Featured Videos";
            lst1.PageDescription = Resources.vsk.videos_featured_desc; // "Browse best featured videos";
            lst1.NoRecordFoundText = Resources.vsk.videos_featured_notfound; //  "No Featured Videos Found!";
            lst1.isFeatured = 1; // load both featured and normal videos
            lst1.isAudio = 0; // load only videos
            lst1.isPrivate = 0; // load only public videos
            lst1.Order = "v.date_added desc, v.liked desc, v.views desc";
            lst1.isCache = true;
            lst1.PageSize = Site_Settings.Video_Page_Size;
            lst1.TabIndex = 0; // Recently Added
            // pagination urls
            lst1.DefaultUrl = "videos/featured/";
            lst1.Pagination_Url = "videos/featured/default_[p].aspx";
            // top navigation urls
            lst1.Recent_Url = "videos/featured/";
            lst1.MostViewed_Url = "videos/featured/mostviewed.aspx";
            lst1.MostFavorited_Url = "videos/featured/mostfavorited.aspx";
            lst1.Toprated_Url = "videos/featured/toprated.aspx";
            lst1.MostCommented_Url = "videos/featured/mostcommented.aspx";

            set_bread_links();
        }
    }

    private void set_bread_links()
    {
        string _rooturl = Config.GetUrl();
        StringBuilder str = new StringBuilder();
        str.Append("<li><a href=\"" + _rooturl + "\">" + Resources.vsk.home + "</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li><a href=\"" + _rooturl + "videos/\">Videos</a><span class=\"divider\">/</span> </li>\n");
        str.Append("<li class=\"active\">Featured Videos</li>\n");
        bread.InnerHtml = str.ToString();
    }

    // Core script to handle website layout
    private void Process_Layout()
    {
        UGeneral ug = new UGeneral();
        int selected_layout_option = Site_Settings.NavigationSection;
        if (selected_layout_option == 2)
        {
            // three column layout
            navigation1.Visible = false; // advance navigation disable
            navigation_sm1.Visible = true; // first column simple navigation
            third_nav1.Visible = true; // third column navigation
        }
        else
        {
            // two column layout
            navigation1.Visible = true;
            navigation_sm1.Visible = false;
            third_nav1.Visible = false;

        }

        NavigationClass = ug.Return_Navigation_Class();
        BodyClass = ug.Return_Body_Class();
        BodyRight = ug.Return_RightNav_Class();

    }
}