﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Web.UI.HtmlControls;
public partial class videos_modules_confirm : System.Web.UI.UserControl
{

    protected string FileName = "";
    protected bool isAudio = false;
    protected DateTime ProcessStartTime = DateTime.Now;
    public int MediaType
    {
        get
        {
            if (ViewState["MediaType"] != null)
                return (int)ViewState["MediaType"];
            else
                return 0;
        }
        set
        {
            ViewState["MediaType"] = value;
        }
    }
    public long GalleryID
    {
        get
        {
            if (ViewState["GalleryID"] != null)
                return (long)ViewState["GalleryID"];
            else
                return 0;
        }
        set
        {
            ViewState["GalleryID"] = value;
        }
    }

    public string UserName
    {
        get
        {
            if (ViewState["UserName"] != null)
                return ViewState["UserName"].ToString();
            else
                return "";
        }
        set
        {
            ViewState["UserName"] = value;
        }
    }

    public int TotalRecords
    {
        get
        {
            if (ViewState["TotalRecords"] != null)
                return (int)ViewState["TotalRecords"];
            else
                return 0;
        }
        set
        {
            ViewState["TotalRecords"] = value;
        }
    }

    public bool SelectedRecord
    {
        get
        {
            if (ViewState["SelectedRecord"] != null)
                return (bool)ViewState["SelectedRecord"];
            else
                return false;
        }
        set
        {
            ViewState["SelectedRecord"] = value;
        }
    }

    public bool isAdmin
    {
        get
        {
            if (ViewState["isAdmin"] != null)
                return (bool)ViewState["isAdmin"];
            else
                return false;
        }
        set
        {
            ViewState["isAdmin"] = value;
        }
    }

    public long GroupID
    {
        get
        {
            if (ViewState["GroupID"] != null)
                return (long)ViewState["GroupID"];
            else
                return 0;
        }
        set
        {
            ViewState["GroupID"] = value;
        }
    }

    public bool GroupMember = false;
    public bool GroupAdmin = false;
    public bool GroupOwner = false;
    public int GroupPermission = 0;
    public int ContentStatus = 0; // adding content to group

    public string Tags = "";
    public string Categories = "";

    // jquery proc function
    protected string ValidateEnc = "";
    protected void Page_PreRender(object sender, EventArgs e)
    {
        if (!Page.IsPostBack)
        {
            if (Request.Params["fn"] != null)
            {
                this.FileName = Request.Params["fn"].ToString();
            }

            ValidateEnc = "";

            if (this.MediaType == 1)
                this.isAudio = true;

            if (Request.Params["gd"] != null)
            {
                this.GroupID = Convert.ToInt64(Request.Params["gd"]);
            }

            BindList();

            
        }
    }

    private void BindList()
    {
        long MaxVideoId = 0;
        if (Request.Params["mpid"] != null)
        {
            MaxVideoId = Convert.ToInt64(Request.Params["mpid"]);
        }
        List<Video_Struct> _list = VideoBLL.Fetch_Finalized_Videos(this.GalleryID, this.TotalRecords, this.UserName, MaxVideoId);
        if (_list.Count > 0)
        {
            Config.ShowMessageV2(msg, "Selected Files uploaded successfully!", "Success!", 1);

            MyList.DataSource = _list;
            MyList.DataBind();
            main.Visible = true;
            norecord.Visible = false;
        }
        else
        {          
            main.Visible = false;
            norecord.Visible = true;
            norecord.InnerHtml = "<h4>" + Resources.vsk.novideosuploaded + "</h4>";
        }
    }


    protected void MyList_ItemDataBound(object sender, DataListItemEventArgs e)
    {
        if (e.Item.ItemType == ListItemType.Item || e.Item.ItemType == ListItemType.AlternatingItem)
        {
            modules_item_videoitem item = (modules_item_videoitem)e.Item.FindControl("macc_itm1");
            item.VD = (Video_Struct)e.Item.DataItem;
            item.MediaType = this.MediaType;

            RadioButton r_package = (RadioButton)e.Item.FindControl("r_package");

            HtmlGenericControl scat = (HtmlGenericControl)e.Item.FindControl("scat");
            HtmlGenericControl mcat = (HtmlGenericControl)e.Item.FindControl("mcat");

            TextBox txt_tags = (TextBox)e.Item.FindControl("txt_tags");
            if (this.Tags != "")
                txt_tags.Text = this.Tags;

            ListBox l_category = (ListBox)e.Item.FindControl("l_category");
            DropDownList drp_category = (DropDownList)e.Item.FindControl("drp_category");
            int ctype = 0;
            if (this.MediaType == 1)
                ctype = 7;
            // load parent / child categories
            if (Site_Settings.AllowMultipleCategoryListing)
            {
                // Multiple category selection is on
                CategoriesBLL.BindCategories(l_category, 0, ctype, " " + Resources.vsk.selectcategory + " ", " ", false);
                scat.Visible = false;
            }
            else
            {
                // Single category selection is on
                // load parent / child categories
                CategoriesBLL.BindCategories(drp_category, 0, ctype, " " + Resources.vsk.selectcategory + " ", " ", false);
                mcat.Visible = false;
            }
            if(this.Categories!="")
            {
                if (Site_Settings.Feature_Categories == 1)
                {
                    if (Site_Settings.AllowMultipleCategoryListing)
                    {
                        // multile categories
                        UGeneral.SelectMultipleItems(l_category, this.Categories);
                    }
                    else
                    {
                        // single category
                        drp_category.SelectedValue = this.Categories.ToString();
                    }
                }
            }
            if (this.GalleryID == 0)
                r_package.Enabled = false;
            else
            {
                string script = "SetUniqueRadioButton('MyList.*ppackages',this)";
                r_package.Attributes.Add("onclick", script);
            }
        }
    }

    protected void btn_bupdate_Click(object sender, EventArgs e)
    {
        Delete_Records();
        long videoid = Selected_Photo_Id();
        Update_Records(videoid);
    }
    protected void btn_update_Click(object sender, EventArgs e)
    {
        Delete_Records();
        long videoid = Selected_Photo_Id();
        Update_Records(videoid);
    }

    private void Update_Records(long videoid)
    {
        
        int index = 0;
        bool flg = false;

        VideoItem itm = new VideoItem();
        itm.Width = 130;
        itm.Height = 72;
        itm.ShowViews = false;
        itm.ShowDate = false;
        itm.ShowAuthor = false;
        itm.ShowDescription = false;
        itm.ShowTags = false;
        itm.ShowCategories = false;
        itm.BoxSpace = 5;
        if (this.TotalRecords == 1)
        {
            // only single video or audio uploaded
            itm.ContentLayout = 1;
            itm.BoxWidth = 0;
            itm.LeftWidth = 27;
            itm.RightWidth = 72;
            itm.ShowTitle = true;
            itm.TitleLength = 0;
            itm.ShowDescription = true;
            itm.DescriptionLength = 100;
            itm.NormalTextCssClass = "normal-text light";
        }
        else
        {
            itm.ShowTitle = false;
            itm.ContentLayout = 0;
            itm.BoxWidth = 150;
            itm.BoxSpace = 15; // space between each item
        }
        if (this.MediaType == 1)
            itm.Type = 1;

        int countvideos = 0;
        StringBuilder pstr = new StringBuilder();
        for (index = 0; index <= MyList.Items.Count - 1; index++)
        {          

            long VideoID = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_photoid")).Text);
            string caption = ((TextBox)MyList.Items[index].FindControl("txt_caption")).Text;
            string tags =  ((TextBox)MyList.Items[index].FindControl("txt_tags")).Text;
            string description = ((TextBox)MyList.Items[index].FindControl("txt_description")).Text;
            string _categories = "";
            // categories enabled
            if (Site_Settings.AllowMultipleCategoryListing)
            {
                ListBox l_category = (ListBox)MyList.Items[index].FindControl("l_category");
                _categories = UGeneral.ReturnSelectedCategories(l_category);
            }
            else
            {
                DropDownList drp_category = (DropDownList)MyList.Items[index].FindControl("drp_category");
                _categories = drp_category.SelectedValue;
            }
            string filename = ((Label)MyList.Items[index].FindControl("lbl_filename")).Text;
          
            Video_Struct ph = new Video_Struct();
            ph.VideoID = VideoID;
            ph.Title = caption;
            ph.Tags = tags;
            ph.Categories = _categories;
            ph.Description = UtilityBLL.Process_Content(description);
            VideoBLL.Update_Info(ph);
            countvideos++;
           
            if (countvideos <= 3)
            {
                ph.UserName = this.UserName;
                ph.ThumbFileName = filename;
                if (this.TotalRecords == 1)
                {
                    // only display if single video is uploaded
                    ph.Title = caption;
                    ph.Description = UtilityBLL.Process_Content(UtilityBLL.StripHTML(description));
                }
                pstr.Append(itm.Process(ph));
            }
           
            if (flg == false)
                flg = true;
        }

        // Generate User Activity
        //******************************************************************************
        string _username = this.UserName;
        string _usr_link = "<a class=\"bold\" href=\"" + UrlConfig.Prepare_User_Profile_Url(_username, this.isAdmin) + "\"  title=\"" + _username + "\">" + _username + "</a>";
        StringBuilder gstr = new StringBuilder();
        gstr.Append("<div class=\"item_pad_2\">\n");
        gstr.Append(pstr.ToString());
        gstr.Append("<div class=\"clear\"></div>\n");
        gstr.Append("</div>\n");

        string _mtype = "videos";
        if (this.MediaType == 1)
            _mtype = "audio";
        string _title = "uploaded " + countvideos + " " + _mtype;
        UserActivity_Struct ustr = new UserActivity_Struct();
        ustr.UserName = _username;
        ustr.Title = _title;
        ustr.Activity = gstr.ToString(); // generate video or audio preview item
        ActivityBLL.Add(ustr);

        
        //******************************************************************************
        // send notification mail to admin
        if (!this.isAdmin)
        {
            MailProcess.Admin_New_Content_Added(UserName, _mtype, "");
        }

        if (this.MediaType == 0)
        {
            if (this.isAdmin)
                Response.Redirect(Config.GetUrl("adm/sc/videos/"), true);
            else
                Response.Redirect(Config.GetUrl("myaccount/MyVideos.aspx?status=uploaded"), true);
        }
        else
        {
            if (this.isAdmin)
                Response.Redirect(Config.GetUrl("adm/sc/videos/?mdp=1"), true);
            else
                Response.Redirect(Config.GetUrl("myaccount/audio/?status=uploaded"), true);
        }
    }

  
    private void Delete_Records()
    {
        int index = 0;
        bool flg = false;
        for (index = 0; index <= MyList.Items.Count - 1; index++)
        {
            CheckBox select_chk;
            select_chk = (CheckBox)MyList.Items[index].FindControl("chk_delete");
            if (select_chk.Checked)
            {
                long ImageID = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_photoid")).Text);
                string filename = ((Label)MyList.Items[index].FindControl("lbl_filename")).Text;
                string username = ((Label)MyList.Items[index].FindControl("lbl_username")).Text;

                VideoBLL.RemoveVideo(ImageID, MediaType);
                if (flg == false)
                    flg = true;
            }
        }
    }

    private long Selected_Photo_Id()
    {
        int index = 0;
        long photoid = 0;
        for (index = 0; index <= MyList.Items.Count - 1; index++)
        {
            if (index == 0)
                photoid = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_photoid")).Text); // choose first one by default
            RadioButton r_pacakge = (RadioButton)MyList.Items[index].FindControl("r_package");
            if (r_pacakge.Checked)
            {
                photoid = Convert.ToInt64(((Label)MyList.Items[index].FindControl("lbl_photoid")).Text);
            }
        }
        return photoid;
    }

    private void MailTemplateProcess(string ownerusername, string username, int totalphotos, string inboxurl)
    {
        //if sending mail option enabled
        if (Config.isEmailEnabled())
        {
            System.Collections.Generic.List<Struct_MailTemplates> lst = MailTemplateBLL.Get_Record("GRPVDPST");
            if (lst.Count > 0)
            {
                string subject = MailProcess.Process2(lst[0].Subject, "\\[ownerusername\\]", ownerusername);
                subject = MailProcess.Process2(subject, "\\[username\\]", username);
                subject = MailProcess.Process2(subject, "\\[totalvideos\\]", totalphotos.ToString());

                string contents = MailProcess.Process2(lst[0].Contents, "\\[ownerusername\\]", ownerusername);
                contents = MailProcess.Process2(contents, "\\[username\\]", ownerusername);

                string group_url = Config.GetUrl("group/" + this.GroupID + ".aspx");
                string url = "<a href=\"" + group_url + "\">" + group_url + "</a>";

                contents = MailProcess.Process2(contents, "\\[url\\]", url);

                contents = MailProcess.Process2(contents, "\\[inboxurl\\]", inboxurl);
                contents = MailProcess.Process2(contents, "\\[totalvideos\\]", totalphotos.ToString());

                string emailaddress = members.Return_Value(ownerusername, "email");

                MailProcess.Send_Mail(emailaddress, subject, contents);
            }
        }
    }
}